/*
 * Created on 27 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package automate;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.Stack;
import java.util.Map;

/**
 * Un determiniseur sait construire un automate dterministe  partir
 * d'un automate non dterministe sans epsilon-transition.
 * @author rosmord
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Determiniseur {

	/**
	 * Cette table sert  spcifier l'association entre les noeuds de l'automate
	 * rsultat et les ensembles de noeuds de l'automate d'origine.
	 */
	private Map correspondanceEnsembleNoeud;

	/**
	 * Le rsultat de l'opration.
	 */
	private Automate result;

	/**
	 * La pile des ensemble de noeuds  traiter.
	 */

	private Stack p;

	/**
	 *  noeudsTraites : ensemble des ensembles de noeuds dj traits
	 */
	
	Set noeudsTraites;

	/**
	 * 
	 * @param source
	 * @return
	 */
	public Automate determiniser(Automate source) {
		result = new Automate();
		// Algorithme de dterminisation :
		// P : pile d'ensemble de noeuds  traiter.
		p = new Stack();

		// noeudsTraites : ensemble des ensembles de noeuds dj traits
		noeudsTraites = new HashSet();

		// nouveau : Noeud (utilis pour dsigner les nouveaux noeuds crs)
		Noeud nouveau;
		// correspondanceEnsembleNoeud : Map
		//      les clefs sont des ensemble de noeuds de source,
		//		les valeurs sont des noeuds de result.
		correspondanceEnsembleNoeud = new HashMap();

		Noeud n;
		// Soit n0 le noeud initial de source
		n = source.getInitial();

		// P.empiler({n0}) // Noter que {n0} est un ensemble
		Set singleton = new HashSet();
		singleton.add(n);
		p.push(singleton);
		// associer le noeud initial de resultat  {n0}		
		correspondanceEnsembleNoeud.put(singleton, result.getInitial());
		// empiler {n0} dans la pile des ensembles  traiter :

		// noeudsTraites= ensemble vide.

		// tant que ! P.estVide()
		while (!p.isEmpty()) {

			//		s = P.depiler()
			Set s = (Set) p.pop();
			//		si s n'est pas dans noeudsTraites
			if (!noeudsTraites.contains(s)) {
				//	liste des labels ports par les arcs des noeuds de s.
				Set labels = new HashSet();

				//			labels = ensemble vide
				//			// liste des labels sortant de s : 
				//			pour tout noeud n dans s
				//				pour tout arc a partant de n
				//					labels.ajouter(a.getLabel())
				//				finpour
				//			finpour
				for (Iterator it = s.iterator(); it.hasNext();) {
					n = (Noeud) (it.next());
					for (Iterator il = n.getArcsSortants().iterator();
						il.hasNext();
						) {
						Arc a = (Arc) (il.next());
						labels.add(a.getLabel());
					}
				}
				//			// labels contient maintenant l'ensemble des labels des lments
				//					sortant de s.
				//
				//			pour tout label l dans labels :
				//				ensembleArrivee : Ensemble (des noeuds auquels on aboutit par l)
				//				ensembleArrivee= ensemble vide		
				//				pour tout noeud n de s
				//					pour tout arc a partant de n
				//						si le label de a est gal  l :
				//							ensembleArrivee.ajouter(a.noeudArrivee())
				//						finsi
				//					finpour
				//				finpour
				for (Iterator il = labels.iterator(); il.hasNext();) {
					Character l = (Character) il.next();
					Set ensembleArrivee = new HashSet();
					for (Iterator in = s.iterator(); in.hasNext();) {
						n = (Noeud) in.next();
						for (Iterator ia = n.getArcsSortants().iterator();
							ia.hasNext();
							) {
							Arc a = (Arc) (ia.next());
							if (a.getLabel().equals(l)) {
								ensembleArrivee.add(a.getArrivee());
							}
						}
					}
					// 				Remarque : le "si" qui suit est en fait gr par la
					//							mthode getNode.
					//				si m ne contient pas ensembleArrivee comme clef :
					//					nouveau= creer un noeud
					//					si un des noeuds de s est final, marquer nouveau comme final
					//					m[ensembleArrivee]= nouv
					// 					p.empiler(ensembleArrivee);
					//				finsi
					//				result.ajouter(m[s],m[ensembleArrivee], l)
					p.add(ensembleArrivee);
					result.addArc(getNode(s), getNode(ensembleArrivee), l);
				}
				//			finpour
				//			ajouter s  l'ensemble des noeudsTraites.
				noeudsTraites.add(s);
				// 		finsi
			}
		} //	fintantque		
		return result;
	}

	/**
	 * retourne le noeud de l'automate rsultat qui est associ avec l'ensemble s.
	 * S'il n'y a pas de noeud associ  s, cette mthode en cre un.
	 * @param s un ensemble de noeuds de l'automate source.
	 * @return un Noeud
	 */
	private Noeud getNode(Set s) {
		if (correspondanceEnsembleNoeud.containsKey(s)) {
			return (Noeud) correspondanceEnsembleNoeud.get(s);
		} else {
			Noeud n = result.creerNoeud();
			// Si un noeud de s est terminal, alors n est terminal.
			for (Iterator i = s.iterator(); i.hasNext();) {
				if (((Noeud) i.next()).isTerminal()) {
					n.setTerminal(true);
				}
			}
			correspondanceEnsembleNoeud.put(s, n);
			return n;
		}
	}

}
